package imt.personnes;

import static imt.concours.ConcoursTest.CHEF_1;
import static imt.concours.FileConcoursTest.CONCOURS_1;
import static imt.concours.FileConcoursTest.CONCOURS_2;
import static imt.concours.FileConcoursTest.CONCOURS_3;
import static imt.concours.FileConcoursTest.forcerLaFinDuConcours;
import static imt.ingredients.IngredientTest.AUTRE;
import static imt.ingredients.IngredientTest.OIGNON;
import static imt.ingredients.IngredientTest.STEAK;
import static org.assertj.core.api.Assertions.assertThat;

import java.util.List;
import java.util.Set;

import org.junit.jupiter.api.Test;

import imt.concours.Concours;
import imt.concours.FileConcours;
import imt.ingredients.Ingredient;
import imt.ingredients.Plat;

public class ChefTest {
	@Test
	void plat_connus_d_un_chef_par_calories() {
		Plat plat1 = new Plat(1, "plat1", new Ingredient[] {
			OIGNON, STEAK
		});
		Plat plat2 = new Plat(2, "plat2", new Ingredient[] {
			OIGNON, AUTRE
		});
		Plat plat3 = new Plat(3, "plat3", new Ingredient[] {
			STEAK, AUTRE
		});

		Chef chef = new Chef(1, "mister", "toto", "06 .", Genre.HOMME, 2, Specialite.CUISINIER, Set.of(plat1, plat2, plat3));

		assertThat(chef.getPlatsParCalories()).isEqualTo(List.of(
			plat1,
			plat3,
			plat2
		));
	}

	@Test
	void augmentation_d_etoiles_pour_une_victoire() {
		Concours CONCOURS_1 = CONCOURS_1();
		Concours CONCOURS_2 = CONCOURS_2();

		FileConcours fileConcours = new FileConcours(CONCOURS_1, CONCOURS_2, CONCOURS_3());
		forcerLaFinDuConcours(CONCOURS_1);
		Chef gagnant = fileConcours.passerAuConcoursSuivant().get();

		// assertThat(gagnant).isEqualTo(CHEF_1);
		// assertThat(CHEF_1.getEtoiles()).isEqualTo(1);
		// TODO
		assertThat(false).isTrue();
	}

	@Test
	void etoiles_selon_victoires() {
		Chef zeroEtoile = new Chef(1, "null", "null", "null", Genre.HOMME, 0, null, null);
		
		assertThat(zeroEtoile.getEtoiles()).isZero();
		
		Chef uneEtoile = new Chef(1, "null", "null", "null", Genre.HOMME, 1, null, null);

		assertThat(uneEtoile.getEtoiles()).isOne();

		Chef deuxEtoiles = new Chef(1, "null", "null", "null", Genre.HOMME, 3, null, null);

		assertThat(deuxEtoiles.getEtoiles()).isEqualTo(2);

		Chef troisEtoile = new Chef(1, "null", "null", "null", Genre.HOMME, 5, null, null);

		assertThat(troisEtoile.getEtoiles()).isEqualTo(3);
	}
}
